Software/KPICore/ViewModels/DataWarehouse/DataWarehouseGeneralInformationViewModel.cs
using Domain.DataWarehouse;
using Domain.Enums.DataWareHouse;
using System;

namespace AEWeb.ViewModels.DataWarehouse
{
    public class DataWarehouseGeneralInformationViewModel
    {

        public string CollectionName { get; set; }
        public int NumberOfRecords { get; set; }
        public DataWareHouseType DWType { get; set; }
        public DateTime LastUpdateDate { get; set; }
        public static DataWarehouseGeneralInformationViewModel FromItem(DataWarehouseRecord item)
        {
            DataWarehouseGeneralInformationViewModel result = new DataWarehouseGeneralInformationViewModel()
            {
                CollectionName = item.CollectionName,
                NumberOfRecords = item.NumberOrRecords,
                DWType = item.DWType,
                LastUpdateDate = item.LastUpdateDate
            };
            return result;
        }

        public string LastUpdateDateForDisplay
        {
            get{
                return LastUpdateDate.ToString("dd/MM/yyyy");
            }
        }
    }
}

Software/KPICore/Controllers/DataWarehouse/DataWarehouseGeneralInformationController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http.Headers;
using System.Threading.Tasks;
using AEWeb.ViewModels.DataWarehouse;
using Domain.Repository;
using Domain.Utils;
using Framework.Service;
using Infrastructure.ViewModels.Shared;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json;

namespace AEWeb.Controllers.DataWarehouse
{
    public class DataWarehouseGeneralInformationController : Controller
    {
        private ILogger<DataWarehouseGeneralInformationController> _logger;
        private IDataWarehouseRepository _repository;
        private IDataWareHouseGenericSQLRepository _SQLDWRepository;
        private IWebHostEnvironment _hostingEnvironment;
        private IExcelReader _excelReader;
        public DataWarehouseGeneralInformationController(ILogger<DataWarehouseGeneralInformationController> logger,
            IDataWarehouseRepository repository, 
            IWebHostEnvironment hostingEnvironment, 
            IDataWareHouseGenericSQLRepository sqlRepository,
            IExcelReader excelReader)
        {
            _logger = logger;
            _repository = repository;
            _SQLDWRepository = sqlRepository;
            _hostingEnvironment = hostingEnvironment;
            _excelReader = excelReader;
        }

        [HttpGet]
        [Authorize]
        public async Task<IActionResult> Index()
        {
            List<Domain.DataWarehouse.DataWarehouseRecord> list = await _repository.GetDataWarehouseRecords();
            DataWarehouseGeneralInformationListViewModel model = DataWarehouseGeneralInformationListViewModel.FromDataWarehouseRecordList(list);

            return View(model);
        }

        [HttpGet]
        [Authorize]
        public IActionResult ResetAllDataWerehouse()
        {
            _SQLDWRepository.DeleteAllDataWarehouseRecords();
            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        [Authorize]
        public IActionResult DeleteDataWareHouseByDate(DataWarehouseGeneralInformationListViewModel data)
        {
            MessagesViewModel messages = new MessagesViewModel();
            if (data.FromDate == null || data.UntilDate == null)
            {
                messages.ErrorMessages.Add("Error in dates");
                TempData["Messages"] = messages.GetJSONMessages();
                return RedirectToAction(nameof(Index));
            }

            if(data.FromDate >= data.UntilDate)
            {
                messages.ErrorMessages.Add("Error the from date cannot be greater than until date");
                TempData["Messages"] = messages.GetJSONMessages();
                return RedirectToAction(nameof(Index));
            }

            _SQLDWRepository.DeleteTableDataWarehouseByDate(data.DWTypeSelected, data.FromDate, data.UntilDate);
            messages.Messages.Add("Delete succsesfully");
            TempData["Messages"] = messages.GetJSONMessages();
            return RedirectToAction(nameof(Index));
        }

        [HttpGet]
        [Authorize]
        public IActionResult ResetClassifierDataWerehouse()
        {
            _SQLDWRepository.ResetClassifierDataWareHouse();
            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        [Authorize]
        public async Task<IActionResult> UploadExcelDataWareHouse(DataWarehouseGeneralInformationListViewModel model, IFormFile file)
        {
            MessagesViewModel messages = new MessagesViewModel();
            if (file == null)
                return RedirectToAction(nameof(Index));
            string JsonData = System.IO.File.ReadAllText(_hostingEnvironment.ContentRootPath + "/DataFiles/SpName.json");
            
            List<TableSPDatawareHouse> listTableSP = 
                JsonConvert.DeserializeObject<List<TableSPDatawareHouse>>(JsonData);

            var fileContent = ContentDispositionHeaderValue.Parse(file.ContentDisposition);
            using (var stream = file.OpenReadStream())
            {
                List<string> errors = new List<string>();
                List<DataWareHouseDataSet> list = _excelReader.ReadExcelSpreadhseetForDataWareHouseSP(stream, errors, listTableSP);
                if(errors.Count > 0)
                {
                    messages.ErrorMessages.Add("Error in excel");
                    List<Domain.DataWarehouse.DataWarehouseRecord> listDW = await _repository.GetDataWarehouseRecords();

                    model = DataWarehouseGeneralInformationListViewModel.FromDataWarehouseRecordList(listDW);
                    model.Errors = errors;
                    return View("Index", model);
                }
                else
                {
                    try
                    {
                        _SQLDWRepository.InsertDatawareHouse(list, model.AloneNextDate);
                        messages.Messages.Add("Inserted successfully");
                    } catch(Exception q)
                    {
                        _logger.LogError(q, "Failed to insert in datawarehouse");
                        messages.ErrorMessages.Add("Failed to insert data, view logs");
                    }
                }
            }
            TempData["Messages"] = messages.GetJSONMessages();
            return RedirectToAction(nameof(Index));
        }
    }
}

Software/KPICore/Views/DataWarehouseGeneralInformation/Index.cshtml
@using Microsoft.AspNetCore.Mvc.Localization
@model AEWeb.ViewModels.DataWarehouse.DataWarehouseGeneralInformationListViewModel
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
    ViewBag.Title = "Data warehouse";
    var stylepnlUpdate = "display:none";
}

<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-lg-10">
        <h2>@Localizer["PageTitle"]</h2>
        <small>@Localizer["PageDescription"]</small>
    </div>
    <div class="col-lg-2">

    </div>
</div>


<div class="wrapper wrapper-content">
    <div class="row">
        <div class="col-lg-12">
            <div class="ibox">
                <div class="ibox-title">
                    <a asp-action="ResetAllDataWerehouse" asp-controller="DataWarehouseGeneralInformation" class="text-decoration-none">
                        <i class="fa fa-trash"></i> @Localizer["BtnDeleteAll"]
                    </a>
                    <a asp-action="ResetClassifierDataWerehouse" asp-controller="DataWarehouseGeneralInformation" class="text-decoration-none">
                        <i class="fa fa-trash"></i> @Localizer["BtnDeleteClassifier"]
                    </a>
                    <a id="buttonUploadActive" class="text-decoration-none" href="#">
                        <i class="fa fa-arrow-up"></i> @Localizer["BtnUpload"]
                    </a>
                </div>

                <div class="ibox-content">
                    <div class="container-fluid">
                        @if(Model.Errors != null && Model.Errors.Count > 0)
                        {
                            stylepnlUpdate = "display:block";
                        }
                        else
                        {
                            stylepnlUpdate = "display:none";
                        }
                        <div class="row" id="pnlUpload" style="@stylepnlUpdate">
                            <form method="post" action='@Url.Action("UploadExcelDataWareHouse","DataWarehouseGeneralInformation")'>

                                <div class="form-group">
                                    <input asp-for="AloneNextDate" type="checkbox" />
                                    <label asp-for="AloneNextDate" class="control-label">@Localizer["CheckAloneNextDate"]</label>
                                    <span asp-validation-for="AloneNextDate" class="text-danger"></span>
                                </div>

                                <div class="k-content">
                                    <span>
                                        @Localizer["LblFileUpload"]
                                    </span>
                                    @(Html.Kendo().Upload()
                                .Multiple(false)
                                .Name("file")
                                .HtmlAttributes(new { aria_label = "file" })
                                .Validation(validation =>
                                    {
                                        validation.AllowedExtensions("xlsx");
                                    })
                                )

                                    <p style="padding-top: 1em; text-align: left">
                                        <button id="submit" type="submit" class="btn btn-primary">@Localizer["LblUpload"]</button>
                                    </p>

                                </div>
                                <br />
                                @if (Model.Errors != null && Model.Errors.Count > 0)
                                {
                                    <div>
                                        <span>
                                            @Localizer["LblErrors"]
                                        </span>
                                        @foreach (string error in Model.Errors)
                                        {
                                            <br />
                                            <span> @error </span>
                                        }
                                    </div>
                                }
                            </form>
                        </div>
                        @if (Model.CollectionList.Count > 0)
                        {
                            <div class="row mb-2">
                                <div class="col-md-6 col-xs-12 pt-2">
                                    <div class="dataTables_info" id="DataTables_Table_0_info" role="status"
                                         aria-live="polite">
                                        @Model.MessageNumberEntries
                                    </div>
                                </div>
                            </div>
                        }
                        <div class="row">
                            <div class="col">
                                <div class="table-responsive">
                                    <table class="table table-striped table-bordered table-hover dataTables-example">
                                        <thead>
                                            <tr>
                                                <th>
                                                    @Localizer["Delete"]
                                                </th>
                                                <th>
                                                    @Localizer["DataCollection"]
                                                </th>
                                                <th>
                                                    @Localizer["NumberRecords"]
                                                </th>
                                                <th>
                                                    @Localizer["LastUpdateDate"]
                                                </th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @if (Model.CollectionList.Count > 0)
                                            {
                                                foreach (var item in Model.CollectionList)
                                                {
                                                    <tr>
                                                        <td>
                                                            @if (item.LastUpdateDate != DateTime.MinValue)
                                                            {
                                                                <a type="button" data-toggle="modal" onclick="ViewModalDate('@item.DWType')" href="#ConfirmDelete">
                                                                    <i class="fa fa-trash" style="color:red"></i>
                                                                </a>
                                                            }
                                                        </td>
                                                        <td>
                                                            @Html.DisplayFor(modelItem => item.CollectionName)
                                                        </td>
                                                        <td>
                                                            @Html.DisplayFor(modelItem => item.NumberOfRecords)
                                                        </td>
                                                        <td>
                                                            @if (item.LastUpdateDate != DateTime.MinValue)
                                                            {
                                                                @Html.DisplayFor(modelItem => item.LastUpdateDateForDisplay)
                                                            }
                                                        </td>
                                                    </tr>
                                                }
                                            }
                                            else
                                            {
                                                <tr>
                                                    <td colspan="2" class="text-center">
                                                        @Localizer["NoRecords"]
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="ConfirmDelete" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <form method="post" action='@Url.Action("DeleteDataWareHouseByDate","DataWarehouseGeneralInformation")'>
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="myModalLabel">@Localizer["ConfirmTitle"]</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                </div>
                <div class="modal-body">
                    From:
                    @(Html.Kendo().DatePicker()
                                    .Name("FromDate")
                                    .Value(DateTime.Now)
                                    .HtmlAttributes(new { style = "width: 150px", title = "Date From" })
                            )
                    &nbsp;
                    &nbsp;
                    &nbsp;
                    To:
                    @(Html.Kendo().DatePicker()
                                    .Name("UntilDate")
                                    .Value(DateTime.Now)
                                    .HtmlAttributes(new { style = "width: 150px", title = "Date To" })
                            )
                    &nbsp;
                    @Html.HiddenFor(x => x.DWTypeSelected)
                </div>
                <div class="modal-footer">
                    @*<a asp-action="DeleteDataWareHouseByDate" asp-controller="DataWarehouseGeneralInformation"
                           asp-route-dwType="@Model.DWTypeSelected" asp-route-from="@Model.FromDate" asp-route-until="@Model.UntilDate"
                           class="text-decoration-none">
                            <i class="fa fa-trash"></i> @Localizer["BtnDeleteAll"]
                        </a>*@
                    <button id="submit" type="submit" class="btn btn-danger">Delete</button>
                    <button type="button" class="btn btn-default" data-dismiss="modal">@Localizer["LblClose"]</button>
                </div>
            </div>
        </form>
    </div>
</div>


<script>
    $(function () {
        $("#buttonUploadActive").click(function () {
            $("#pnlUpload").css("display", "block");
        });
    });

    function ViewModalDate(dwType) {
        $('#DWTypeSelected').val(dwType);
    }
</script>